<?php
class ControllerExtensionModuleUnusedOptions extends Controller {
	private $error = array();

	public function getTotalOptions() {

        $result = $this->db->query("SELECT COUNT(*) AS total FROM `" . DB_PREFIX . "option`");

        return $result->row['total'];
        
	}

	public function getTotalActiveOptions() {

		$result = $this->db->query("SELECT COUNT(DISTINCT option_id) AS total FROM " . DB_PREFIX . "product_option");

		return $result->row['total'];

	}

	public function deleteUnusedOptions() {

		$results = $this->db->query("SELECT DISTINCT option_id FROM `" . DB_PREFIX . "product_option`");

		$options = array();

        foreach ($results->rows as $result) {

        	$options[]=$result['option_id'];

    }

     	$this->db->query("DELETE FROM `" . DB_PREFIX . "option` WHERE option_id NOT IN(".implode(",", $options).")");

     	$this->db->query("DELETE FROM `" . DB_PREFIX . "option_description` WHERE option_id NOT IN(".implode(",", $options).")");

     	$this->db->query("DELETE FROM `" . DB_PREFIX . "option_value` WHERE option_id NOT IN(".implode(",", $options).")");

     	$this->db->query("DELETE FROM `" . DB_PREFIX . "option_value_description` WHERE option_id NOT IN(".implode(",", $options).")");

    	$this->session->data['success'] = 'Deleted';

		$this->response->redirect($this->url->link('extension/module/UnusedOptions', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
	}

	public function index() {
		$this->load->language('extension/module/UnusedOptions');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			if (!isset($this->request->get['module_id'])) {
				$this->model_setting_module->addModule('UnusedOptions', $this->request->post);
			} else {
				$this->model_setting_module->editModule($this->request->get['module_id'], $this->request->post);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		$data['options_total'] = $this->getTotalOptions();

        $data['options_active_total'] = $this->getTotalActiveOptions();

        $data['options_in_active_total'] = (int)$this->getTotalOptions()- (int)$this->getTotalActiveOptions();

        if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

		$data['delete_option'] = $this->url->link('extension/module/UnusedOptions/deleteUnusedOptions', 'user_token=' . $this->session->data['user_token'], true);



		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/module/UnusedOptions', 'user_token=' . $this->session->data['user_token'], true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/module/UnusedOptions', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true)
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/UnusedOptions', 'user_token=' . $this->session->data['user_token'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/UnusedOptions', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true);
		}

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_setting_module->getModule($this->request->get['module_id']);
		}

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}
 
		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/UnusedOptions', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/UnusedOptions')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		return !$this->error;
	}
}